﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace GridView
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.radGridView1.Rows.Add(new GridViewDataRowInfo(this.radGridView1.MasterView));

            this.radGridView1.ValueChanged += radGridView1_ValueChanged;
        }
        
        int maxLength = 10;

        private void radGridView1_ValueChanged(object sender, EventArgs e)
        {
            if (this.radGridView1.ActiveEditor == null)
            {
                return;
            }
            string value = this.radGridView1.ActiveEditor.Value.ToString();
            if (value.Length == maxLength)
            {
                int newColumnIndex = this.radGridView1.CurrentColumn.Index + 1;
                if (newColumnIndex >= this.radGridView1.Columns.Count)
                {
                    int newRowIndex = this.radGridView1.CurrentRow.Index + 1;
                    if (this.radGridView1.Rows.Count == newRowIndex)
                    {
                        this.radGridView1.Rows.Add(new GridViewDataRowInfo(this.radGridView1.MasterView));
                        this.radGridView1.CurrentRow = this.radGridView1.Rows[newRowIndex];
                    }

                    newColumnIndex = 0;
                }

                this.radGridView1.CurrentColumn = this.radGridView1.Columns[newColumnIndex];
            }
        }
    }
}
